You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 

397 lines
18 KiB

  1. #!/bin/bash
  2. set -e
  3. cd "$(readlink -f $(dirname $0))"
  4. if [ -n "${GBP_BUILD_DIR}" ]; then
  5. cd "$GBP_BUILD_DIR"
  6. fi
  7. VERSION=$(dpkg-parsechangelog | sed -n -e '/^Version:/s/^Version: //p')
  8. DISTRIBUTION=$(dpkg-parsechangelog | sed -n -e '/^Distribution:/s/^Distribution: //p')
  9. LIBAPTPKGVERSION="$(awk -v ORS='.' '/^\#define APT_PKG_M/ {print $3}' apt-pkg/contrib/macros.h | sed 's/\.$//')"
  10. librarysymbolsfromfile() {
  11. local MISSING="$(grep '^+#MISSING' "$1")"
  12. local SYMVER="$2"
  13. echo '=== Missing optional symbols:'
  14. echo -n "$MISSING" | grep '|optional=' || true
  15. echo '=== Missing required symbols:'
  16. echo -n "$MISSING" | grep -v '|optional=' || true
  17. echo '=== New symbols:'
  18. grep '^+ ' "$1" | grep -v '^+ (c++' | cut -d' ' -f 2 | cut -d'@' -f 1 | c++filt | while read line; do
  19. echo " (c++)\"${line}@${SYMVER}\" $VERSION"
  20. done | sort -u
  21. }
  22. test_deb_control() {
  23. echo "Package: apt-test-depends"
  24. echo "Version: 1.0"
  25. echo "Architecture: all"
  26. printf "Depends:"
  27. (
  28. for i in Build-Depends Build-Depends-Indep Build-Depends-Arch; do
  29. grep-dctrl -ns $i -S apt ./debian/control && echo ,
  30. done
  31. grep-dctrl -ns Depends -F Tests run-tests ./debian/tests/control
  32. ) | tr '\n' ' '\
  33. | sed -r -e 's#<[^,<>()@]*>##g' \
  34. -e 's#@[^,<>()@]*@##g' \
  35. -e 's#\[linux-any\]*##g' \
  36. -e 's#\[[^][]*\]*##g' \
  37. -e 's#dpkg-dev \([^)]*\)#dpkg-dev#g' \
  38. -e 's#debhelper \([^)]*\)#debhelper#g' \
  39. -e 's#g\+\+ \([^)]*\)#g++#g' \
  40. -e 's#@##g' \
  41. -e 's#,(\s+,)+#, #g' \
  42. -e 's#\s+# #g'
  43. }
  44. if [ "$1" = 'pre-export' ]; then
  45. libraryversioncheck() {
  46. local LIBRARY="$1"
  47. local VERSION="$2"
  48. if [ ! -e "debian/${LIBRARY}${VERSION}.symbols" ]; then
  49. echo >&2 "Library ${LIBRARY} in version ${VERSION} has no symbols file! (maybe forgot to rename?)"
  50. exit 1
  51. fi
  52. if [ "$(head -n1 "debian/${LIBRARY}${VERSION}.symbols")" != "${LIBRARY}.so.${VERSION} ${LIBRARY}${VERSION} #MINVER#" ]; then
  53. echo >&2 "Library ${LIBRARY}${VERSION} has incorrect version in symbol header! (»$(head -n1 "debian/${LIBRARY}${VERSION}.symbols")«)"
  54. exit 2
  55. fi
  56. }
  57. libraryversioncheck 'libapt-pkg' "$LIBAPTPKGVERSION"
  58. if [ "$DISTRIBUTION" = 'sid' ]; then
  59. echo >&2 '»sid« is not a valid distribution. Replace it with »unstable« for you'
  60. sed -i -e 's/) sid; urgency=/) unstable; urgency=/' debian/changelog
  61. DISTRIBUTION='unstable'
  62. elif [ "$DISTRIBUTION" = 'UNRELEASED' ]; then
  63. echo >&2 'WARNING: Remember to change to a valid distribution for release'
  64. VERSION="$VERSION~$(date +%Y%m%d)"
  65. fi
  66. sed -i -e "s/^set(PACKAGE_VERSION \".*\")$/set(PACKAGE_VERSION \"${VERSION}\")/" CMakeLists.txt
  67. sed -i -e "s/^<!ENTITY apt-product-version \".*\">$/<!ENTITY apt-product-version \"${VERSION}\">/" doc/apt-verbatim.ent
  68. # update the last-modification field of manpages based on git changes
  69. grep --files-with-matches '<date>' doc/*.xml | while read file; do \
  70. LASTMOD="$(date -d "@$(git log -i --format='%at' --max-count=1 --invert-grep --fixed-strings --grep 'review
  71. typo
  72. release
  73. Git-Dch: Ignore
  74. Gbp-Dch: ignore' "$file")" '+%Y-%m-%dT00:00:00Z')"
  75. sed -i -e "s#^\([ ]\+\)<date>.*</date>\$#\1<date>$LASTMOD</date>#" "$file"
  76. done
  77. if [ "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' po/apt-all.pot | cut -d' ' -f 2)" -o \
  78. "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' doc/po/apt-doc.pot | cut -d' ' -f 2)" ]; then
  79. echo >&2 'POT files are not up-to-date. Execute »make update-po« for you…'
  80. [ -e build ] || mkdir build
  81. ( cd build && cmake .. )
  82. cmake --build build --target update-po -- -j 4
  83. fi
  84. elif [ "$1" = 'pre-build' ]; then
  85. if [ "$DISTRIBUTION" = "UNRELEASED" ]; then
  86. echo 'BUILDING AN UNRELEASED VERSION'
  87. else
  88. CONFVERSION="$(sed -ne "s/^set(PACKAGE_VERSION \"\(.*\)\")$/\1/p" CMakeLists.txt)"
  89. if [ "$VERSION" != "$CONFVERSION" ]; then
  90. echo "changelog (${VERSION}) and CMakeLists.txt (${CONFVERSION}) talk about different versions!"
  91. echo "You probably want to run »./prepare-release pre-export« to fix this."
  92. exit 1
  93. fi
  94. NEWSDISTRIBUTION=$(dpkg-parsechangelog -l debian/NEWS | sed -n -e '/^Distribution:/s/^Distribution: //p')
  95. if [ "$NEWSDISTRIBUTION" = 'UNRELEASED' ]; then
  96. echo "changelog (${VERSION}) has a distribution (${DISTRIBUTION}) set, while the NEWS file hasn't!"
  97. echo "You probably want to edit »debian/NEWS« to fix this."
  98. exit 1
  99. fi
  100. fi
  101. elif [ "$1" = 'post-build' ]; then
  102. if [ "$DISTRIBUTION" != "UNRELEASED" ]; then
  103. echo >&2 "REMEMBER: Tag this release with »git tag -s ${VERSION}« if you are satisfied"
  104. else
  105. echo >&2 'REMEMBER: Change to a valid distribution before release'
  106. fi
  107. dpkg-checkbuilddeps -d 'libxml2-utils'
  108. HEADERBLUEPRINT="$(mktemp)"
  109. sed -n '1,/^$/p' doc/apt.8.xml > "$HEADERBLUEPRINT"
  110. find doc -mindepth 1 -maxdepth 1 -type f -name '*.xml' | while read FILE; do
  111. if ! sed -n '1,/^$/p' "$FILE" | cmp "$HEADERBLUEPRINT" - >/dev/null 2>&1; then
  112. echo >&2 "WARNING: Manpage $FILE has not the usual header! (see diff below)"
  113. sed -n '1,/^$/p' "$FILE" | diff -u "$HEADERBLUEPRINT" - || true
  114. fi
  115. done
  116. sed -n '1,/^$/p' doc/guide.dbk > "$HEADERBLUEPRINT"
  117. find doc -mindepth 1 -maxdepth 1 -type f -name '*.dbk' | while read FILE; do
  118. if ! sed -n '1,/^$/p' "$FILE" | cmp "$HEADERBLUEPRINT" - >/dev/null 2>&1; then
  119. echo >&2 "WARNING: Documentation $FILE has not the usual header (see diff below)!"
  120. sed -n '1,/^$/p' "$FILE" | diff -u "$HEADERBLUEPRINT" - || true
  121. fi
  122. done
  123. rm "$HEADERBLUEPRINT"
  124. # check the manpages with each vendor for vendor-specific errors…
  125. find vendor -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 2 | while read DISTRO; do
  126. ln -sf ../vendor/${DISTRO}/apt-vendor.ent doc
  127. if ! xmllint --nonet --valid --noout $(find doc/ -maxdepth 1 -name '*.xml'); then
  128. echo >&2 "WARNING: original docbook manpages have errors with vendor ${DISTRO}!"
  129. fi
  130. done
  131. # lets assume we will always have a german manpage translation
  132. if [ -e */doc/de/ -o -e doc/de ]; then
  133. # … but check the translations only with one vendor for translation-specific errors
  134. if ! xmllint --path /vendor/$(./vendor/getinfo current)/ \
  135. --path doc/ \
  136. --nonet --valid --noout $(find doc/ */doc/ -mindepth 2 -maxdepth 2 -name '*.xml'); then
  137. echo >&2 "WARNING: translated docbook manpages have errors!"
  138. fi
  139. else
  140. echo >&2 "ERROR: translated manpages need to be build before they can be checked!"
  141. fi
  142. rm -f doc/apt-vendor.ent
  143. elif [ "$1" = 'library' ]; then
  144. librarysymbols() {
  145. local libname=$(echo "${1}" | cut -c 4-)
  146. local buildlib="build/bin/${1}.so.${2}"
  147. for dir in $libname */$libname; do
  148. local new_buildlib="$dir/${1}.so.${2}"
  149. if [ -r "${new_buildlib}" ] && [ ! -e "$buildlib" -o "$new_buildlib" -nt "$buildlib" ]; then
  150. local buildlib="${new_buildlib}"
  151. fi
  152. done
  153. if [ ! -r "$buildlib" ]; then
  154. echo "ERROR: The library ${1} has to be built before symbols can be checked!"
  155. return
  156. fi
  157. echo "Checking $1 in version $2 build at $(stat -L -c '%y' "$buildlib")"
  158. local tmpfile=$(mktemp)
  159. dpkg-gensymbols -p${1}${2} -e${buildlib} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile || true
  160. librarysymbolsfromfile "$tmpfile" "$(echo "${1}" | cut -c 4- | tr -d '-' | tr 'a-z' 'A-Z')_${2}"
  161. rm -f $tmpfile
  162. }
  163. librarysymbols 'libapt-pkg' "${LIBAPTPKGVERSION}"
  164. echo
  165. elif [ "$1" = 'buildlog' ]; then
  166. while [ -n "$2" ]; do
  167. librarysymbolsfromfile "$2" 'UNKNOWN'
  168. shift
  169. done
  170. elif [ "$1" = 'travis-ci' ]; then
  171. apt-get install -qy --no-install-recommends dctrl-tools equivs gdebi-core moreutils
  172. test_deb_control > test-control
  173. equivs-build test-control
  174. gdebi -n apt-test-depends_1.0_all.deb
  175. elif [ "$1" = 'coverage' ]; then
  176. DIR="${2:-./coverage}"
  177. git clean -dfX # remove ignored build artifacts for a clean start
  178. make CFLAGS+='--coverage' CXXFLAGS+='--coverage'
  179. LCOVRC='--rc geninfo_checksum=1 --rc lcov_branch_coverage=1'
  180. mkdir "$DIR"
  181. lcov --no-external --directory . --capture --initial --output-file "${DIR}/apt.coverage.init" ${LCOVRC}
  182. make test || true
  183. ./test/integration/run-tests -q || true
  184. lcov --no-external --directory . --capture --output-file "${DIR}/apt.coverage.run" ${LCOVRC}
  185. lcov -a "${DIR}/apt.coverage.init" -a "${DIR}/apt.coverage.run" -o "${DIR}/apt.coverage.total" ${LCOVRC}
  186. cp "${DIR}/apt.coverage.total" "${DIR}/apt.coverage.fixed"
  187. rewritefile() {
  188. file="$1"
  189. shift
  190. name="$(basename "$file")"
  191. while [ -n "$1" ]; do
  192. if [ -r "$1/$name" ]; then
  193. sed -i "s#$file#$1/$name#" "${DIR}/apt.coverage.fixed"
  194. break
  195. fi
  196. shift
  197. done
  198. if [ -z "$1" ]; then
  199. echo >&2 "Coverage data captured for unknown file $file"
  200. fi
  201. }
  202. grep 'build/include/' "${DIR}/apt.coverage.fixed" | sed "s#^SF:$(pwd)/##" | while read file; do
  203. rewritefile "$file" 'apt-pkg' 'apt-pkg/deb' 'apt-pkg/edsp' 'apt-pkg/contrib' \
  204. 'apt-private'
  205. done
  206. genhtml --output-directory "${DIR}" "${DIR}/apt.coverage.fixed" ${LCOVRC}
  207. elif [ "$1" = 'spellcheckers' -o "$1" = 'lint' ]; then
  208. is_available() {
  209. if dpkg-checkbuilddeps -d "$1" 2>/dev/null; then
  210. return 0
  211. fi
  212. echo "### SKIPPING ${2:-$1} functionality as ${1} isn't installed"
  213. }
  214. if is_available 'codespell'; then
  215. echo '### codespell in source directories:'
  216. codespell --enable-colors $(find . -mindepth 1 -maxdepth 1 -type d \! -name '.git' \! -name 'doc' \! -name 'po' \! -name 'build' \! -name 'test') \
  217. | grep -v -e '^.*debian/changelog.*Troup.*==>.*Troupe.*$' \
  218. -e '^.*debian/changelog.*readd.*==>.*readd.*$' \
  219. -e '^.*debian/changelog.*Tim.*==>.*Time.*$' \
  220. -e '^.*apt-pkg/contrib/fileutl\.cc.*creat.*==>.*create.*$' \
  221. -e '^.*apt-pkg/pkgcache\.h.*mmaped.*==>.*mapped.*$' \
  222. -e '^.*apt-pkg/pkgcachegen\.cc.*mmaped.*==>.*mapped.*$' \
  223. -e '^.*apt-pkg/contrib/mmap\.h.*mmaped.*==>.*mapped.*$' \
  224. -e '^.*cmdline/apt-key\.in.*dashs.*==>.*dashes.*$' \
  225. -e '^.*methods/aptmethod\.h.*creat.*==>.*create.*$' \
  226. -e '^.*dselect/install.*ans.*==>.*and.*$' \
  227. -e '^.*ftparchive/writer\.h.*Delink.*==>.*Unlink.*$' \
  228. -e '^.*ftparchive/writer\.cc.*De[Ll]ink.*==>.*[Uu]nlink.*$' \
  229. || true
  230. echo '### codespell in testcases:'
  231. codespell --enable-colors $(find test -type f \! -name 'status-*' \! -name 'Packages-*' \! -name '*.deb' \! -name '*.sec' \! -name '*.pub' \! -name '*.db') \
  232. | grep -v -e '^.*test/libapt/file-helpers\.cc.*creat.*==>.*create.*$' \
  233. -e '^.*test/libapt/tagfile_test\.cc.*tyes.*==>.*types.*$' \
  234. -e '^.*test/libapt/strutil_test\.cc.*Fiel.*==>.*Feel.*$' \
  235. -e '^.*test/libapt/cdromfindpackages_test\.cc.*Signatur.*==>.*Signature.*$' \
  236. -e '^.*test/integration/skip-bug-601016-description-translation.*Paket.*==>.*Packet.*$' \
  237. -e '^.*test/integration/skip-bug-601016-description-translation.*Wege.*==>.*Wedge.*$' \
  238. -e '^.*test/integration/skip-bug-601016-description-translation.*Methoden.*==>.*Methods.*$' \
  239. -e '^.*test/integration/test-apt-update-not-modified.*readd.*==>.*readd.*$' \
  240. || true
  241. echo '### codespell in documentation:'
  242. codespell --enable-colors doc/*.xml doc/*.txt doc/*.dbk doc/*.ent doc/*.cmake.in doc/xml.add doc/po4a.conf doc/examples doc/po/apt-doc.pot \
  243. po/apt-all.pot README.* COPYING \
  244. | grep -v -e '^.*po/apt-all\.pot.*DeLink.*==>.*unlink.*$' \
  245. || true
  246. fi
  247. if is_available 'lintian' 'spellintian'; then
  248. echo '### spellintian in source directories:'
  249. {
  250. for DIR in $(find . -mindepth 1 -maxdepth 1 -type d \! -name '.git' \! -name 'doc' \! -name 'po' \! -name 'build' \! -name 'test'); do
  251. spellintian $(find "$DIR" -type f)
  252. done
  253. } \
  254. | grep -v \
  255. -e '^.*: long long (duplicate word) -> long$' \
  256. -e '^./apt-pkg/pkgcache.h: ID ID (duplicate word) -> ID$' \
  257. -e '^./apt-pkg/contrib/mmap.cc: WorkSpace WorkSpace (duplicate word) -> WorkSpace$' \
  258. -e '^./apt-pkg/contrib/md5.cc: z z (duplicate word) -> z$' \
  259. -e '^./apt-pkg/metaindex.cc: const const (duplicate word) -> const$' \
  260. -e '^./apt-pkg/acquire-method.cc: QueueBack QueueBack (duplicate word) -> QueueBack$' \
  261. -e '^./CMake/Translations.cmake: domain domain (duplicate word) -> domain$' \
  262. -e '^./CMake/apti18n.h.in: m m (duplicate word) -> m$' \
  263. -e '^./CMake/run_if_exists.sh: fi fi (duplicate word) -> fi$' \
  264. -e '^./ftparchive/byhash.cc: ByHash ByHash (duplicate word) -> ByHash$' \
  265. -e '^./ftparchive/writer.cc: this Packages -> these packages$' \
  266. -e '^./ftparchive/byhash.h: ByHash ByHash (duplicate word) -> ByHash$' \
  267. -e '^./cmdline/apt-key.in: done done (duplicate word) -> done$' \
  268. -e '^./cmdline/apt-key.in: fi fi (duplicate word) -> fi$' \
  269. -e '^./cmdline/apt-key.in: echo echo (duplicate word) -> echo$' \
  270. -e '^./triehash/.travis.yml: perl perl (duplicate word) -> perl$' \
  271. -e '^./triehash/README.md: Performance Performance (duplicate word) -> Performance$' \
  272. -e '^./debian/apt.apt-compat.cron.daily: fi fi (duplicate word) -> fi$' \
  273. -e '^./debian/apt.auto-removal.sh: done done (duplicate word) -> done$' \
  274. -e '^./debian/apt.systemd.daily: fi fi (duplicate word) -> fi$' \
  275. -e '^./debian/apt.postinst: fi fi (duplicate word) -> fi$' \
  276. -e '^./methods/http.cc: Sz Sz (duplicate word) -> Sz$' \
  277. -e '^./methods/ftp.cc: AFMap AFMap (duplicate word) -> AFMap$' \
  278. -e '^./dselect/install: fi fi (duplicate word) -> fi$' \
  279. -e '^./CMake/Documentation.cmake: endforeach endforeach (duplicate word) -> endforeach$' \
  280. -e '^./apt-pkg/deb/deblistparser.cc: c c (duplicate word) -> c$' \
  281. -e '^./apt-private/private-install.cc: result result (duplicate word) -> result$' \
  282. -e '^./debian/changelog: the the (duplicate word) -> the$' \
  283. -e '^./debian/changelog: procceed -> proceed$' \
  284. -e '^./methods/aptmethod.h: QueueBack QueueBack (duplicate word) -> QueueBack$' \
  285. || true
  286. echo '### spellintian in testcases:'
  287. spellintian $(find test -type f \! -name 'status-*' \! -name 'Packages-*' \! -name '*.deb' \! -name '*.sec' \! -name '*.pub' \! -name '*.db') \
  288. | grep -v \
  289. -e '^.*: long long (duplicate word) -> long$' \
  290. -e '^test/integration/.*: fi fi (duplicate word) -> fi$' \
  291. -e '^test/integration/.*: done done (duplicate word) -> done$' \
  292. -e '^test/integration/.*: echo echo (duplicate word) -> echo$' \
  293. -e '^test/integration/test-00-commands-have-help: moo moo (duplicate word) -> moo$' \
  294. -e '^test/integration/test-apt-cache: bar bar (duplicate word) -> bar$' \
  295. -e '^test/integration/test-sourceslist-trusted-options: everythingsucceeds everythingsucceeds (duplicate word) -> everythingsucceeds$' \
  296. -e '^test/integration/test-sourceslist-trusted-options: everythingfails everythingfails (duplicate word) -> everythingfails$' \
  297. -e '^test/integration/test-apt-get-changelog: foo foo (duplicate word) -> foo$' \
  298. -e '^test/integration/test-ubuntu-bug-761175-remove-purge: testround testround (duplicate word) -> testround$' \
  299. -e '^test/integration/test-apt-get-download: apt apt (duplicate word) -> apt$' \
  300. -e '^test/integration/test-apt-showlist-orgroup-in-recommends: zzz zzz (duplicate word) -> zzz$' \
  301. -e '^test/integration/test-bug-691453-apt-cache-search-multi-pattern: bar bar (duplicate word) -> bar$' \
  302. -e '^test/integration/test-allow: hold hold (duplicate word) -> hold$' \
  303. -e '^test/integration/test-apt-by-hash-update: ensureitsbroken ensureitsbroken (duplicate word) -> ensureitsbroken$' \
  304. -e '^test/integration/test-apt-source-and-build-dep: foo foo (duplicate word) -> foo$' \
  305. || true
  306. echo '### spellintian in documentation:'
  307. spellintian doc/*.xml doc/*.txt doc/*.dbk doc/*.ent doc/*.cmake.in doc/xml.add doc/po4a.conf doc/examples/* doc/po/apt-doc.pot po/apt-all.pot README.* COPYING \
  308. | grep -v \
  309. -e '^doc/examples/configure-index: https https (duplicate word) -> https$' \
  310. || true
  311. fi
  312. # stay true to the old name
  313. if [ "$1" = 'spellcheckers' ]; then exit; fi
  314. if is_available 'i18nspector'; then
  315. echo '### i18nspector on translation files:'
  316. i18nspector po/*.po po/*.pot doc/po/*.pot doc/po/*.po \
  317. | grep -v \
  318. -e '^I: po/es.po: duplicate-header-field X-POFile-SpellExtra$' \
  319. || true
  320. fi
  321. elif [ "$1" = "merge-translations" ]; then
  322. if [ -z "$2" ]; then
  323. echo "Usage:\t$0 $1 <branch to merge from>" >&2
  324. exit 1
  325. fi
  326. for i in {doc/,}po/*.po ; do
  327. # 1. concatenate the translations, picking new translations
  328. # 2. merge the translations so we only have matching translations left
  329. # 3. remove any newly introduced obsolete translations (only in $2)
  330. # 4. concatenate again to restore "old" obsolete translations
  331. # 5. write output
  332. msgcat --use-first <(git show $2:$i) $i \
  333. | msgmerge --no-fuzzy --previous - $i \
  334. | msgattrib --no-obsolete - \
  335. | msgcat --use-first - $i \
  336. | sponge $i
  337. done
  338. else
  339. echo >&1 "Usage:\t$0 pre-export
  340. \t$0 pre-build
  341. \t$0 post-build
  342. Updating po-files and versions as well as some basic checks are done
  343. by »pre-export« which needs to be run before package building.
  344. If you use »gbp buildpackage« you will be notified if you forget.
  345. »pre-build« and »post-build« can be used to run some more or less
  346. useful checks automatically run by »gbp« otherwise.
  347. \t$0 library
  348. \t$0 buildlog filename…
  349. »library« and »buildlog« aren't run automatically but can be useful for
  350. maintaining the (more or less experimental) symbols files we provide.
  351. »library« displays the diff between advertised symbols and the once provided
  352. by the libraries, while »buildlog« extracts this diff from the buildlogs.
  353. Both will format the diff properly.
  354. \t$0 travis-ci
  355. \t$0 coverage [output-dir]
  356. »travis-ci« is a shortcut to install all build- as well as test-dependencies
  357. used by .travis.yml.
  358. »coverage« does a clean build with the right flags for coverage reporting,
  359. runs all tests and generates a html report in the end.
  360. \t$0 spellcheckers
  361. »spellcheckers« runs »codespell« and »spellintian« on the appropiate files and
  362. filters out obvious false positives.
  363. \t$0 merge-translations branch
  364. Merge translations from the given branch.
  365. "
  366. fi